#include<stdio.h>
#include<string.h>
#include "tfb2any.h"
#include "y.tab.h"
extern int lineno;
int skip(void);   /* $B6uGr2~9T$OHt$P$7$F<!$N(B1$BJ8;z$rFI$_9~$`(B */
int commentskip(void);  /* $B%3%a%s%H$rFI$_$H$P$9(B */
int follow(int,int,int);    /* 2$BJ8;z$+$i$J$k%H!<%/%s$N2DG=@-$rD4$Y$k(B */

/*
  tfb2openmath.y$B$G$@$1%H!<%/%s(BDEC$B$,Dj5A$5$l$F$$$k$N$G(B,
  $BB>$N;~$ODj5A$5$l$F$$$J$$(B($B$H$$$&$+;H$o$J$$(B)
  $B%3%s%Q%$%k;~$K$O%(%i!<$,$G$k$N$G(Bifdef$BJ8$r;H$C$F(BDEC$B$r8+$($J$$$h$&$K$9$k(B
*/

/***************************
NUMBER:$B?t;z(B -> value$B$K$O?t;zNs(B
VAR:$BJQ?t(B    -> value$B$K$OJQ?tL>(B($BBeF~J8$rH/8+$9$k$HJQ?t$HH=CG(B)
HUTEIGEN:$BITDj85(B -> value$B$K$OITDj85L>(B
STRING:$BJ8;zNs(B   -> value$B$K$O%@%V%k%/%*!<%H$r=|$$$?J8;zNs(B
CONST:$BDj?t(B      -> value$B$K$O(Basirconst@,mathconst@$B$r=|$$$?J8;zNs(B
PREVIOUS:$BA02s$NEz$((B -> value$B$K$O(B"@@"   -> $B$^$@$I$&$9$k$+L$Dj(B
DEC: ->tfb2openmath$B$N$H$-$N$_>.?t(B.$BB>$N;~$O@0?t$b>.?t$b(BNUMBER
***************************/


int yylex(void)
{
  int c;
  int c1;
  char value[200];   /* $B;CDjE*$K?t;zNs$dJQ?t$NL>A0$J$I$rF~$l$kNN0h(B */
  char *p=value;
 
  c=skip();     /* $B%3%a%s%H2~9T6uGr%?%V$O$H$P$7(B */
  /* printf("%c\n",c);     $B%G%P%C%0(B:$B$3$3$b(Bifdef$BJ8;H$C$F$k$H3Z$@$C$?(B */
  if(c==EOF)
	return 0;
  if(isdigit(c)){     /* NUMBER, or DEC($B>.?t(B:tfb2openmath$B$N$H$-$N$_(B)*/
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && isdigit(c));
	if(c!='.'){         /* $B>.?t$G$J$$(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(NUMBER,NONE,value);
	  return NUMBER;
	}      /* $B>.?tE@$N<!$rFI$`(B */
	if((c1=getchar())=='.'){   /* $B>.?tE@$,#2$DO"B3(B->RANGE */
	  ungetc(c,stdin);    /* .$B$r#2$DI8=`F~NO$XJQ49(B */
	  ungetc(c,stdin);
	  *p='\0';
	  yylval.sym=makesymbol(NUMBER,NONE,value);
	  return NUMBER;
	}
	ungetc(c1,stdin);      /* 1$BJ8;z(B($B>.?tE@$N<!$NJ8;z(B)$BJV4T(B  */
	do{                 /* $B>.?tE@0J2<$N%3%T!<(B */
	  *p++=c;
	}while((c=getchar())!=EOF && isdigit(c));
	*p='\0';
	ungetc(c,stdin);

#ifdef DEC
	yylval.sym=makesymbol(DEC,NONE,value);
	return DEC;
#endif
	/* $BB>$NJQ49$N;~$O>.?t$b(BNUMBER$B$G$"$k(B */
	yylval.sym=makesymbol(NUMBER,NONE,value);
	return NUMBER;
  }
  
  /*           $B$7$P$i$/%3%a%s%H(B
			   if(isupper(c)){    
			   do{
			   *p++=c;
			   }while((c=getchar())!=EOF && (isalnum(c) || c=='_'));
			   *p='\0';
			   ungetc(c,stdin);
			   yylval.sym=makesymbol(VAR,NONE,value);
			   return VAR;
			   }
  */
  
  if(islower(c)){
    /*tfb2pmathml$B$N;~$@$1$N%H!<%/%s$N@Z$jJ}(B:$BFI$`?M$O$^$:$O$3$N(Bifdef$B$OHt$P$9(B*/
#ifdef INV_FUNC 
	/* tfb2pmathml$B$N$H$-$O(B_$B$OBg;v$JLr3d$J$s$G(B.. */
	do{                  /* HUTEIGEN$B$O(B_$B$r4^$s$G$O$$$1$J$$(B */
	  *p++=c;            /* tfb2pmathml$B$N;~$@$1$NFCJL$J%H!<%/%s$N@Z$jJ}(B */
	}while((c=getchar())!=EOF && isalnum(c));
	*p='\0';
	
	/*****  $B$3$3$+$i!:@ZD>A0%X%?%/%=%3!<%I$N;O$^$j(B         *****/	
	if(c=='@'){   /*$B$b$7$b<!$,(B@$B$@$C$?$i4X?t$+$b(B*/
	  if(strcmp("asir",value)==0){   /* asir@$B4X?tL>$N7A$+!)(B */
		p=value;     /* $B#0$+$iFI$_9~$_D>$7(B(asir@$B$rFI$_$H$P$7(B)  */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){/*@$B0J2<FI$_9~$_(B*/
		  *p++=c;                                /*$B$D$^$j4X?tL>$NFI$_9~$_(B*/
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,ASIR,value);
		return FUNCTION;
	  }
	  if(strcmp("math",value)==0){ /* math@$B4X?tL>$N7A$+!)(B */
		p=value;   /* $B$3$3$N(Bif$BJ8$,$$$/$D$bB3$/>iD9$5$O4X?t$K$9$l$P$J$/$;$=$&(B */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){
		  *p++=c;                                
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,MATH,value);
		return FUNCTION;		
	  }
	  if(strcmp("maple",value)==0){ /* maple@$B4X?tL>$N7A$+!)(B */
		p=value;   /* $B$3$3$N(Bif$BJ8$,$$$/$D$bB3$/>iD9$5$O4X?t$K$9$l$P$J$/$;$=$&(B */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){
		  *p++=c;                                
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,MAPLE,value);
		return FUNCTION;		
	  }
	  if(strcmp("matlab",value)==0){ /* matlab@$B4X?tL>$N7A$+!)(B */
		p=value;   /* $B$3$3$N(Bif$BJ8$,$$$/$D$bB3$/>iD9$5$O4X?t$K$9$l$P$J$/$;$=$&(B */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){
		  *p++=c;                                
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,MATLAB,value);
		return FUNCTION;		
	  }
	}

	if(c=='.'){ /* $B%b%8%e!<%k4X?t8F$S=P$7!)(B */
	  do{
		*p++=c;  /*$BB>$N$H$-$O(BMODULE$B4X?tMQ(B*/
	  }while((c=getchar())!=EOF && (isalnum(c) || c=='_'));	  
	  ungetc(c,stdin);
	  *p='\0';
	  yylval.sym=makesymbol(MODULE,NONE,value);
	  return MODULE;
	}

	ungetc(c,stdin);
	/* $B%=%U%HL>(B@$B$N7A$G$O$J$+$C$?(B->$BITDj85(B?ROOT?SQRT? */
	if(strcmp("sqrt",value)==0)
	  return SQRT;
	if(strcmp("root",value)==0)
	  return ROOT;   
	yylval.sym=makesymbol(HUTEIGEN,NONE,value);
	return HUTEIGEN;
	/************ $B$3$3$^$G!:@ZA0%X%?%/%=%3!<%I(B  *****************/
#endif
	
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && (isalnum(c) || c=='_'));
	if(c=='.'){ /*tfb2openmath:FUNCTION$B$O(Bcdname.func$B$N7A(B*/
	  do{
		*p++=c;  /*.$B$O(Btfb2openmath$B$G$O(BFUNCTION$BMQ(B,$BB>$N$H$-$O(BMODULE$B4X?tMQ(B*/
	  }while((c=getchar())!=EOF && (isalnum(c) || c=='_'));	  
	  ungetc(c,stdin);
	  *p='\0';

#ifdef MODULE
	  yylval.sym=makesymbol(MODULE,NONE,value);
	  return MODULE;
#endif
	  
	  /* openmath */
#ifndef MODULE
	  yylval.sym=makesymbol(DOT_FUNC,OPENMATH,value);
	  return DOT_FUNC;   /* hoge.b */
#endif

	}
	
	*p='\0';
	/* $B<B83(B */
	if(c=='@'){   /*$B$b$7$b<!$,(B@$B$@$C$?$i4X?t$+$b(B*/
	  if(strcmp("asir",value)==0){   /* asir@$B4X?tL>$N7A$+!)(B */
		p=value;     /* $B#0$+$iFI$_9~$_D>$7(B(asir@$B$rFI$_$H$P$7(B)  */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){/*@$B0J2<FI$_9~$_(B*/
		  *p++=c;                                /*$B$D$^$j4X?tL>$NFI$_9~$_(B*/
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,ASIR,value);
		return FUNCTION;
	  }
	  if(strcmp("math",value)==0){ /* math@$B4X?tL>$N7A$+!)(B */
		p=value;   /* $B$3$3$N(Bif$BJ8$,$$$/$D$bB3$/>iD9$5$O4X?t$K$9$l$P$J$/$;$=$&(B */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){
		  *p++=c;                                
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,MATH,value);
		return FUNCTION;		
	  }
	  if(strcmp("maple",value)==0){ /* maple@$B4X?tL>$N7A$+!)(B */
		p=value;   /* $B$3$3$N(Bif$BJ8$,$$$/$D$bB3$/>iD9$5$O4X?t$K$9$l$P$J$/$;$=$&(B */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){
		  *p++=c;                                
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,MAPLE,value);
		return FUNCTION;		
	  }
	  if(strcmp("matlab",value)==0){ /* matlab@$B4X?tL>$N7A$+!)(B */
		p=value;   /* $B$3$3$N(Bif$BJ8$,$$$/$D$bB3$/>iD9$5$O4X?t$K$9$l$P$J$/$;$=$&(B */
		while((c=getchar())!=EOF && (isalnum(c)||c=='_')){
		  *p++=c;                                
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(FUNCTION,MATLAB,value);
		return FUNCTION;		
	  }
	  
	  /* $B$3$3$h$j>e$O4X?t!"2<$ODj?t(B */
	  
	  
	  if(strcmp("asirconst",value)==0){
		p=value;
		while((c=getchar())!=EOF && (isalnum(c) || c=='_')){
		  *p++=c;
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(CONST,ASIR,value);
		return CONST;
	  }
	  if(strcmp("mathconst",value)==0){
		p=value;
		while((c=getchar())!=EOF && (isalnum(c) || c=='_')){
		  *p++=c;
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(CONST,MATH,value);
		return CONST;
	  }
	  if(strcmp("mapleconst",value)==0){
		p=value;
		while((c=getchar())!=EOF && (isalnum(c) || c=='_')){
		  *p++=c;
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(CONST,MAPLE,value);
		return CONST;
	  }
	  if(strcmp("matlabconst",value)==0){
		p=value;
		while((c=getchar())!=EOF && (isalnum(c) || c=='_')){
		  *p++=c;
		}
		ungetc(c,stdin);
		*p='\0';
		yylval.sym=makesymbol(CONST,MATLAB,value);
		return CONST;
	  }
	}
	ungetc(c,stdin);       /* asir@$B$J$I$,IU$$$F$J$$(B->$BJQ?t(Bor$BITDj85(B */
	if(lookup(value)==1){     /* $BJQ?t%F!<%V%k$r8!:w(B  */
	  yylval.sym=makesymbol(VAR,NONE,value);
	  return VAR;
	}
	else{
	  yylval.sym=makesymbol(HUTEIGEN,NONE,value);
	  return HUTEIGEN;    /* $BITDj85(B */
	}
  }
  
  if(c=='"'){
	for(;(c=getchar())!='"';p++){
	  if(c=='\n' || c==EOF){
		execerror("missing quote","");
	  }
	  if(p>=value+sizeof(value)-1){
		*p='\0';
		execerror("string too long",value);
	  }
	  *p=c;
	}
	*p='\0';
	yylval.sym=makesymbol(STRING,NONE,value);
	return STRING;
  }
  return c;    /* default */
}  


int skip()
{
  int c;   
  int c1;   /* $B0lJ8;z@h$^$GFI$`$H$-(B */
  for((c=getchar()) ; ; ){
	switch(c){               
	case ' ': case '\t':  /* $B6uGr$OFI$_$H$P$7(B */
	  c=getchar(); 
	  break;
	case '\n':
	  lineno++;
	  c=getchar();
	  break;
	case '/':             /* / $B$,$-$?(B->$B$5$i$K!v$,$-$?(B->$B%3%a%s%H(B */
	  if((c1=getchar())=='*')
		c=commentskip();    /* $B%3%a%s%H$rFI$_$H$P$7(B */
	  else{
		ungetc(c1,stdin);  /* /$B$N<!$,!v0J30(B->$B3d$j;;1i;;;R(B / $B$HH=Dj(B */
		return c;
	  }
	  break;
	case '=':   return follow('=',EQ,'=');
	case '.':   return follow('.',RANGE,'.');

/* INV_FUNC$B$rDj5A$7$F$$$k$N$O(Btfb2pmathml$B$@$1(B _^$B$G0l$D$N%H!<%/%s(BSUBSUP$B$K(B */
/* INV_FUNC$B$r(Btfb2pmathml$B$+$I$&$+$N;XI8$K$7$F$$$k(B */
#ifdef INV_FUNC 
	case '_':     /* _^$B$+(B__$B$+$?$@$N(B_$B$+(B */
	  if(follow('^',SUBSUP,'_')==SUBSUP)
		return SUBSUP;
	  else{
		return follow('_',UNDER,'_');
	  }
	  break;
	case '^':    /* ^$B$+(B^^$B$+(B */
	  return follow('^',OVER,'^');
	  break;
#endif 

	default:
	  return c;
	  break;
	}
  }  
}


int commentskip()
{
  int c;
  int c1;
  for((c=getchar()); ; ){
	c1=getchar();    /* $B<!$NJ8;z$rFI$^$;$k(B */
	if((c=='*' && c1=='/'))    /* '*'$B$H(B'/'$B$,O"B3$G$-$?(B->$B%3%a%s%H$N=*$j(B */
	  return getchar();       /* $B$5$i$K<!$NJ8;z$rJV$9(B  */
	else
	  c=c1;                    /* c$B$r(Bc1$B$KDI$$$D$+$;$k(B */
  }
}


int follow(int expect,int ifyes,int ifno)  /* look ahead for == etc.. */
{
  int c;
  c=getchar();
  if(c==expect)
	return ifyes;
  else{
	ungetc(c,stdin);
	return ifno;
  }
}
