#include "../common_file/tfb2any.h"
#include "y.tab.h"
#include<stdio.h>
#include<string.h>

/******************

$B9=J8LZ$NI=<((B
presentation mathml(pmath$B$H>JN,$9$k(B)$B$X(B

*******************/

void printtag(char *,char*);  /* $BMWAGL>(B,$BFbMF$+$iMWAG$rI=<((B */
void prtop(char *);    /* $B3+;O%?%0$NI=<((B */
void prbottom(char *); /* $B=*N;%?%0$NI=<((B */
void print_ope(Symbol *,int); /* $B1i;;;R$K$h$k=PNO$N@Z$jBX$((B */
void pr_indent(int);   /* $B%$%s%G%s%H(B */
void printsoftfunc(Symbol *);  /* $B%=%U%HL>(B@$B4X?tL>(B->$B%=%U%HL>(B_$B4X?tL>$r0u;z(B */
extern int math_flag;   /* tfb2pmathml$B$GDj5A(B */
static int depth=0;  /* $B%$%s%G%s%H$N?<$5(B */

void printend(int flag)
{
  if(flag==0)
	printf("\n");
  else
	printf("\n");
}


void print_expr()   /* $BJQ49$7$F$+$i0u;z(B */
{
  Symbol *sp=pop();
  transform(sp);   /* $BJQ49(B */
  if(math_flag==0){
	prtop("math xmlns=\"http://www.w3.org/1998/Math/MathML\"");
	depth++;
  }
  treeprint(sp);   /* $B0u;z(B */
  if(math_flag==0){
	depth--;
	prbottom("math");
  }
}


/* tfb2pmathml$B$G$O#3$D$a$N0z?t$O0UL#$r$b$?$J$$(B */
void treeprint(Symbol *sp)
{
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r0u;z(B */
	check_type(sp,1,0);
	if(sp->type==LIST||sp->type==FUNCTION)/* $B%j%9%H$H4X?t$O(B */
	  check_type(sp,2,0);                   /* $B;R6!$,$$$J$/$F$bJD$83g8LI,MW(B */
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r0u;z(B($B:F5"!K(B */
	check_type(sp,1,0);         /* $B;R6!$r0u;z$9$kA0$K3g8L3+$-!)(B  */
	for(i=0;i<sp->number;i++){
	  treeprint(*((sp->childp)+i));  /* $B;R6!$KBP$7$FF1$8Av::(B */
	  if(i<sp->number-1)/*$B:G8e$N%3%s%^(B.$B$$$l$J$+$C$?$i:G8e$K%3%s%^$,#1$DM>J,(B*/
		check_type(sp,3,i);  /* $B%j%9%H$d4X?t$J$i;R6!$N4V$K%3%s%^$,F~$k(B */
	}
	check_type(sp,2,0);    /* $B;R6!$r0u;z$7$?$"$H3g8LJD$8!)(B */
  }
}


/*
  check_type
  $B%N!<%I$N<oN`$H#2$D$a$N0z?t!J%N!<%IAv::Cf$N(B $B@h(B:$B#1(B $BCf(B:$B#3(B $B8e(B:$B#2(B $B$N$I$l$+!K(B
  $B$K$h$C$FI=<($r@Z$jBX$($k4X?t(B
  $B#3$D$a$N0z?t$O0UL#$J$7(B
*/
void check_type(Symbol *sp,int time,int childnum)
{
  switch(sp->type){
  case NUMBER:
	if(time==1)
	  printtag("mn",sp->value);
	break;
  case VAR:     /* $BBeF~J8L5$$$+$i(BVAR$B$,8=$l$k$3$H$OL5$$$,(B.. */
  case HUTEIGEN:
	if(time==1)
	  printtag("mi",sp->value);
	break;

  case CONST: /*$BDj?t$^$@<h$j07$o$J$$(B.$BE,@Z$J<BBN;2>H$KJQ49$7$?$iJXMx$@$H;W$&(B*/
	if(time==1)
	  printf("%s",sp->value);
	break;

  case STRING:
	if(time==1)
	  printtag("mtext",sp->value);
	break;

  case FUNCTION:   /* $B%=%U%HL>(B@$B4X?tL>(B->$B%=%U%HL>(B_$B4X?tL>$G=PNO$7$h$&(B  */
	if(time==1){    /* $B@h(B */
	  prtop("mrow");   /* $B%0%k!<%W2=(B */
	  depth++;
	  printsoftfunc(sp);
	  printtag("mo","&ApplyFunction;");
	  prtop("mfenced"); /* mfenced:$BB0@-L5$7(B -> ()$B$G0O$&(B */
	  depth++;
	}
	else if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mfenced");
	  depth--;
	  prbottom("mrow");
	}
	/* $BCf(B:$B<+J,$G(B<mo>,</mo>$B$rF~$l$J$/$F$b(B,mfenced$B$N8z2L$G<+F0E*$K(B , $B$,F~$k(B */
	break;


  case P_FUNCTION: /*$B<+A3$J7A$N4X?t8F$S=P$7(Bsin(x)$B$H$+(B.$B%=%U%HL>(B@$B$,$D$$$F$J$$(B */
  case MODULE:     /* $B%b%8%e!<%k4X?t8F$S=P$7$N7A(B */
	if(time==1){    /* $B@h(B */
	  prtop("mrow");   /* $B%0%k!<%W2=(B */
	  depth++;
	  printtag("mi",sp->value);
	  printtag("mo","&ApplyFunction;");
	  prtop("mfenced"); /* mfenced:$BB0@-L5$7(B -> ()$B$G0O$&(B */
	  depth++;
	}
	else if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mfenced");
	  depth--;
	  prbottom("mrow");
	}
	/* $BCf(B:$B<+J,$G(B<mo>,</mo>$B$rF~$l$J$/$F$b(B,mfenced$B$N8z2L$G<+F0E*$K(B , $B$,F~$k(B */
	break;

  case INV_FUNC:    /* invisible func:sinx$B$N$h$&$J7A$G=q$-$?$$$H$-(B */
	if(time==1){    /* $B@h(B */
	  prtop("mrow");   /* $B%0%k!<%W2=(B */
	  depth++;
	  printtag("mi",sp->value);
	  printtag("mo","&ApplyFunction;");   /* $B%+%C%3$G0O$o$J$$(B */
	}
	else if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mrow");
	}
	break;	


  case PARENS:
	if(time==1){
	  prtop("mfenced");  /* ()$B$G0O$`(B */
	  depth++;
	}
	else if(time==2){
	  depth--;
	  prbottom("mfenced");
	}
	break;

  case LIST:
	if(time==1){
	  prtop("mrow");    /* mfenced$B$G$b$G$-$k(B */
	  depth++;
	  printtag("mo","[");
	  prtop("mrow");
	  depth++;
	}
	else if(time==2){
	  depth--;
	  prbottom("mrow");
	  printtag("mo","]");
	  depth--;
	  prbottom("mrow");
	}
	else if(time==3){
	  printtag("mo",",");
	}
	break;
	
  case MATRIX:
	if(time==1){    /* $BA0(B */
	  prtop("mrow");
	  depth++;
	  prtop("mfenced");  /* mfenced$B$NB0@-$GJD$8%+%C%3$N7A$OJQ$($i$l$k(B */
	  depth++;
	  prtop("mtable");
	  depth++;
	}
	else if(time==2){  /* $B8e(B */
	  depth--;
	  prbottom("mtable");
	  depth--;
	  prbottom("mfenced");
	  depth--;
	  prbottom("mrow");
	}
	break;

  case ROW:   /* $B9TNs$N9T(B */
	if(time==1){    /* $BA0(B */
	  prtop("mtr");
	  depth++;
	  prtop("mtd");
	  depth++;
	}
	else if(time==2){  /* $B8e(B */
	  depth--;
	  prbottom("mtd");
	  depth--;
	  prbottom("mtr");
	}
	else if(time==3){  /* $BCf(B */
	  depth--;
	  prbottom("mtd");
	  prtop("mtd");
	  depth++;
	}
	break;

  case UNARYMINUS:
  case UNARYPLUS:
	if(time==1){
	  prtop("mrow");
	  depth++;
	  printtag("mo",sp->value);
	}
	if(time==2){
	  depth--;
	  prbottom("mrow");
	}
	break;


  case OPE:
	if(time==1)   /* 1:$BA0(B,2:$B8e(B,3:$BCf(B */
	  print_ope(sp,1);
	if(time==2)
	  print_ope(sp,2);
	if(time==3)     /* $BCf(B */
	  print_ope(sp,3);
	break;

  case SQRT:  /* $B%k!<%H(B */
	if(time==1){
	  prtop("msqrt");
	  depth++;
	}
	if(time==2){ 
	  depth--;
	  prbottom("msqrt");
	}
	break;

  case ROOT:  /* n$B>h:,(B */
	if(time==1){
	  prtop("mroot");
	  depth++;
	}
	if(time==2){
	  depth--;
	  prbottom("mroot");
	}
	break;	

  case EQ:   /* $BJ}Dx<0(B */
	if(time==1){  /* $BA0(B */
	  prtop("mrow");
	  depth++;
	}
	if(time==2){  /* $B8e(B */
	  depth--;
	  prbottom("mrow");  /* $BCf(B */
	}
	if(time==3)
	  printtag("mo","=");
	break;
	
  }
}



void printtag(char *tag,char *content)
{
  pr_indent(depth);  /* $B%$%s%G%s%H(B*/
  printf("<%s> %s </%s>\n",tag,content,tag);
}


void prtop(char *tag)   /* $B3+;O%?%0$NI=<((B */
{
  pr_indent(depth);  /* $B%$%s%G%s%H(B*/
  printf("<%s>\n",tag);
}


void prbottom(char *tag)  /* $B=*N;%?%0$NI=<((B */
{
  pr_indent(depth);  /* $B%$%s%G%s%H(B*/
  printf("</%s>\n",tag);
}


void print_ope(Symbol *sp,int time)  /* $B1i;;;R$N=PNO(B */
{
  if(strcmp(sp->value,"+")==0){
	if(time==1){   /* $BA0(B */
	  prtop("mrow");
	  depth++;
	}
	if(time==3)  /* $BCf(B */
	  printtag("mo","+");
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mrow");
	}
  }
  
  if(strcmp(sp->value,"-")==0){
	if(time==1){   /* $BA0(B */
	  prtop("mrow");
	  depth++;
	}
	if(time==3)  /* $BCf(B */
	  printtag("mo","-");
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mrow");
	}
  }

  if(strcmp(sp->value,"*")==0){  /* $B?t;zF1;N$N>h;;$N;~$O(B*$B5-9f$,I,MW(B */
	if(time==1){   /* $BA0(B */
	  prtop("mrow");
	  depth++;
	}
	if(time==3){   /* $BCf(B */
	  if(sp->childp[0]->type==NUMBER && (sp->childp[1]->type)==NUMBER)
		printtag("mo","*");
	  else
		printtag("mo","&InvisibleTimes;");
	}
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mrow");
	} 
  }
  
  if(strcmp(sp->value,"/")==0){
	if(time==1){   /* $BA0(B */
	  prtop("mfrac");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$O$J$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mfrac");
	}
  }
  
  if(strcmp(sp->value,"^")==0){
	if(time==1){   /* $BA0(B */
	  prtop("msup");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$OL5$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("msup");
	}
  }
  
  if(strcmp(sp->value,"_")==0){
	if(time==1){   /* $BA0(B */
	  prtop("msub");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$OL5$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("msub");
	}
  } 
  
  if(strcmp(sp->value,"_^")==0){
	if(time==1){   /* $BA0(B */
	  prtop("msubsup");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$OL5$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("msubsup");
	}
  }
  
  if(strcmp(sp->value,"__")==0){  /* _$B$,Fs$DO"B3(B */
	if(time==1){   /* $BA0(B */
	  prtop("munder");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$OL5$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("munder");
	}
  } 
  
  if(strcmp(sp->value,"^^")==0){   /* ^$B$,Fs$DO"B3(B */
	if(time==1){   /* $BA0(B */
	  prtop("mover");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$OL5$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("mover");
	}
  } 
  
  if(strcmp(sp->value,"__^^")==0){    /* $B>e$+$D2<J8;z(B*/
	if(time==1){   /* $BA0(B */
	  prtop("munderover");
	  depth++;
	}
	/* $BCf$KA^F~$9$kMWAG$OL5$$(B */
	if(time==2){   /* $B8e(B */
	  depth--;
	  prbottom("munderover");
	}
  } 	
}


void pr_indent(int n)   /* $B?<$5(Bn$B$N%$%s%G%s%H$r0u;z(B */
{
  int i;
  for(i=0;i<n;i++)
  printf("  ");
}


void printsoftfunc(Symbol *sp)
{
  pr_indent(depth);
  printf("<mi>");

  if(sp->mode==ASIR)
	printf("asir_%s",sp->value);
  if(sp->mode==MATH)
	printf("math_%s",sp->value);
  if(sp->mode==MAPLE)
	printf("maple_%s",sp->value);
  if(sp->mode==MATLAB)
	printf("matlab_%s",sp->value);
  printf("</mi>\n");
}
