#include "../common_file/any2tfb.h"
#include "y.tab.h"
#include<stdio.h>
void head_change_to_lower(Symbol *);   /* $BJQ?t$N@hF,$N;z$r>.J8;z$KJQ49(B */

/******************

$B9=J8LZ$NI=<((B
matlab2tfb$B$G$O(Bcheck_type$B$NBh#30z?t$O(Bstep$BIU$-(BRANGE$B$N;~$N$_$KM-8z(B

*******************/


void printend(int flag)
{
  if(flag==0)
	printf(";\n");
  else
	printf("$\n");
}


void print_expr()
{
  Symbol *sp=pop();
  transform(sp); /* $B%N!<%I$NJQ49(B */
  treeprint(sp);
}


void treeprint(Symbol *sp)
{
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r0u;z(B */
	check_type(sp,1,0); /* $BBh#30z?t$O$J$s$G$b$h$$(B */
	if(sp->type==LIST||sp->type==FUNCTION||sp->type==ROW)/*$B%j%9%H$H4X?t(B*/
	  check_type(sp,2,0); /* $B$H9T$O;R6!$,$$$J$/$F$bJD$83g8LI,MW(B */
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r0u;z(B($B:F5"!K(B */
	check_type(sp,1,0);         /* $B;R6!$r0u;z$9$kA0$K3g8L3+$-!)(B  */
	for(i=0;i<sp->number;i++){
	  treeprint(*((sp->childp)+i));  /*$B;R6!$KBP$7$FF1$8Av::(B*/
	  if(i<sp->number-1)/*$B:G8e$N%3%s%^(B.$B$$$l$J$+$C$?$i:G8e$K%3%s%^$,#1$DM>J,(B*/
		check_type(sp,3,i);  /*$B%j%9%H$d4X?t$J$i;R6!$N4V$K%3%s%^$,F~$k(B*/
	}          /* $BBh#30z?t$O;R6!$NHV9f(B:$BMWAGHV9f$NJQ49$K;H$&(B*/
	check_type(sp,2,0);    /* $B;R6!$r0u;z$7$?$"$H3g8LJD$8!)(B */
  }
}


/*
  check_type
  $B%N!<%I$N<oN`$H#2$D$a$N0z?t!J%N!<%IAv::Cf$N(B $B@h(B:$B#1(B $BCf(B:$B#3(B $B8e(B:$B#2(B $B$N$I$l$+!K(B
  $B$K$h$C$FI=<($r@Z$jBX$($k4X?t(B
  $B#3$DL\$N0z?t$O4v$D$a$N;R$KBP$9$k8F$S=P$7$G$"$k$+$r<($9?t;z(B
  $B#3$DL\$N0z?t$OE:;zJQ49$N;~$K$7$+;H$o$J$$$N$G$"$^$j5$$K$7$J$/$FNI$$(B
*/
void check_type(Symbol *sp,int time,int childnum)
{
  switch(sp->type){
  case NUMBER:
  case PREVIOUS:   /* PREVIOUS$B$,(BMATLAB$B$K$O$J$5$=$&(B */
	if(time==1)
	  printf("%s",sp->value);
	break;

  case VAR:     /* $B%*%V%8%'%/%H$O@hF,$r>.J8;z$K(B */
  case HUTEIGEN:
	if(time==1){
	  if(isupper(sp->value[0]))
		head_change_to_lower(sp);/* $B@hF,$NJ8;z$r>.J8;z$KJQ49$7$F$7$^$*$&(B */
	  printf("%s",sp->value);
	}
	break;
  case CONST:
	if(time==1)
	  printf("matlabconst@%s",sp->value);
	break;
  case STRING:
	if(time==1) 
	  printf("\"%s\"",sp->value);
	break;

  case FUNCTION:
	if(time==1)    /* $B@h(B */
	  printf("matlab@%s(",sp->value);
	else if(time==2)   /* $B8e(B */
	  printf(")");
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;

  case PARENS:
	if(time==1)
	  printf("(");
	else if(time==2)
	  printf(")");
	break;

  case LIST:   /* $B9TNs(B */
	if(sp->number!=1){  /* $B;R(B(ROW)$B$,#1$D$N$H$-$O(B[]$B$,(BROW$B$N$H9g$o$;$F(B */
	  if(time==1)        /* $B#2=E$K$J$k$N$G(B.$BNc(B:[1,2,3]--->[[1,2,3]]$B$K$J$k(B*/
		printf("[");    /* $B$=$l$r2r>C$9$k$?$a$N(Bif$BJ8$,#19TL\(B */
	  else if(time==2)
		printf("]");
	  else if(time==3)
		printf(",");
	}
	break;

  case ROW:    /* $B9TNs$N9T(B */
	if(time==1)
	  printf("[");
	if(time==2)
	  printf("]");
	if(time==3)   /* $BCf(B */
	  printf(",");
	break;
	
  case UNARYMINUS: 
  case UNARYPLUS:
	if(time==1)
	  printf("%s",sp->value);
	break;

  case ELEMENT:
	if(time==1){
	  if(isupper(sp->value[0]))
		head_change_to_lower(sp);
	  printf("%s[",sp->value);
	}
	else if(time==2)
		printf("]");
	else if(time==3)
		printf("][");
	break;

  case OPE:
	if(time==3)
	  printf("%s",sp->value);
	break;
  case ASSIGN:
	if(time==3)
	  printf("=");
	break;
  case EQ:
	if(time==3)
	  printf("==");
	break;
  case RANGE:
	if(time==3)
	  printf("..");
	break;
  case RANGEST:
	if(time==3){
	  if(childnum==0)
		printf("..");
	  else if(childnum==1)
		printf(":");
	}
	break;
  case FUNCTIONELEMENT:    /* $B2?$b$7$J$$?F(B */
	break;
  }
}


void head_change_to_lower(Symbol *sp)   /* value$B$N(B1$BJ8;zL\$r>.J8;z$KJQ99(B */
{
  sp->value[0]+=0x20; /* $BJ8;z%3!<%II=$h$j(B0x20$BB-$;$PBgJ8;z"*>.J8;z$K$J$k(B */
}
