#include "../common_file/tfb2any.h"
#include "y.tab.h"
#include<stdio.h>
#include<string.h>

/******************
$B9=J8LZ$NI=<((B
asir$B$K(B
*******************/
extern int quote_flag; /* tfb2asir.y$B$GDj5A(B:$B=PNO$r(Bquote$B$G0O$`$+$I$&$+$N%U%i%0(B */

void printend(int flag)
{
  if(flag==0)
	printf(";\n");
  else
	printf("$\n");
}


void print_expr()   /* $BJQ49$7$F$+$i0u;z(B  */
{
  Symbol *sp=pop();
  transform(sp);   /* $BJQ49(B  */
  if(quote_flag==1)
	printf("quote(");
  treeprint(sp);   /* $B0u;z(B */
}


void treeprint(Symbol *sp)
{
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r0u;z(B */
	check_type(sp,1,0);
	if(sp->type==LIST||sp->type==SET||sp->type==FUNCTION||sp->type==MODULE)/* $B%j%9%H$H4X?t$O(B */
	  check_type(sp,2,0);                   /* $B;R6!$,$$$J$/$F$bJD$83g8LI,MW(B */
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r0u;z(B($B:F5"!K(B */
	check_type(sp,1,0);         /* $B;R6!$r0u;z$9$kA0$K3g8L3+$-!)(B  */
	for(i=0;i<sp->number;i++){
	  treeprint(*((sp->childp)+i));  /* $B;R6!$KBP$7$FF1$8Av::(B */
	  if(i<sp->number-1)/*$B:G8e$N%3%s%^(B.$B$$$l$J$+$C$?$i:G8e$K%3%s%^$,#1$DM>J,(B*/
		check_type(sp,3,i);  /* $B%j%9%H$d4X?t$J$i;R6!$N4V$K%3%s%^$,F~$k(B */
	}
	check_type(sp,2,sp->number-1);    /* $B;R6!$r0u;z$7$?$"$H3g8LJD$8!)(B */
  }
}


/*
  check_type
  $B%N!<%I$N<oN`$H#2$D$a$N0z?t!J%N!<%IAv::Cf$N(B $B@h(B:$B#1(B $BCf(B:$B#3(B $B8e(B:$B#2(B $B$N$I$l$+!K(B
  $B$K$h$C$FI=<($r@Z$jBX$($k4X?t(B
*/
void check_type(Symbol *sp,int time,int childnum)
{
  switch(sp->type){
  case NUMBER:
  case HUTEIGEN:
  case PREVIOUS:
	if(time==1)
	  printf("%s",sp->value);
	break;
	
  case VAR:
	if(time==1){
	  sp->value[0]-= 0x20;      /* $BBgJ8;z$XJQ49(B */
	  printf("%s",sp->value);   /* $B0u;z(B */
	}
	break;
	
  case CONST:
	if(time==1)
	  printf("@%s",sp->value);
	break;
  case STRING:
	if(time==1)
	  printf("\"%s\"",sp->value);
	break;
	
  case FUNCTION:
	if(time==1){    /* $B@h(B */
	  if(strcmp(sp->value,"erase")!=0)/*$B4X?tL>$,(Berase->$B4X?tL>$H%+%C%3HsI=<((B */
		printf("%s(",sp->value);
	}
	else if(time==2){   /* $B8e(B */
	  if(strcmp(sp->value,"erase")!=0)/*$B4X?tL>$,(Berase->$B4X?tL>$H%+%C%3HsI=<((B */
		printf(")");
	}
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;
	
  case MODULE:  /* module$B4X?t(B */
	if(time==1)    /* $B@h(B */
	  printf("%s(",sp->value);
	else if(time==2)   /* $B8e(B */
	  printf(")");
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;

  case PARENS:
	if(time==1)
	  printf("(");
	else if(time==2)
	  printf(")");
	break;
	
  case LIST:
  case ROW:
  case MATRIX:
  case SET:
	if(time==1)
	  printf("[");
	else if(time==2)
	  printf("]");
	else if(time==3)
	  printf(",");
	break;

  case UNARYMINUS:
  case UNARYPLUS:
	if(time==1)
	  printf("%s",sp->value);
	break;
	
  case ELEMENT:     /* $BE:;z$r#1$D8:$i$9(B */
	
	if(time==1){
	  if(sp->value!=NULL){
		sp->value[0]-=0x20;        /* $B>.J8;z$rBgJ8;z$KLa$9(B */
		printf("%s[",sp->value);
	  }
	  else
		printf("[");   /* NULL$B$J$i%+%C%3$@$1I=<((B*/
	}
	else if(time==2)
	  if(sp->childp[childnum]->type!=NUMBER)
		printf("-1]");  /*NUMBER$B$J$i4{$KE:;z$O#10z$+$l$F$$$k(B*/
	  else   
		printf("]");
	else if(time==3)
	  if(sp->childp[childnum]->type!=NUMBER)
		printf("-1][");   /*NUMBER$B$J$i4{$KE:;z$O#10z$+$l$F$$$k(B*/
	  else 
		printf("][");
	break;

  case OPE:
	if(time==3)
	  printf("%s",sp->value);
	break;

  case RANGE:
	if(time==3)
	  printf("..");
	break;

  case ASSIGN:
	if(time==3)
	  printf("=");
	break;

  case EQ:
	if(time==3)
	  printf("==");
	break;

  case FUNCTIONELEMENT:    /* $B2?$b$7$J$$?F(B */
	break;

  case DP: /* $BJ,;6I=8=B?9`<0(B */
	if(time==1)
	  printf("<<");
	else if(time==2)
	  printf(">>");
	else if(time==3){
	  printf(",");
	}
	break;	

  case VECTOR:     /* $B0J2<(Btest */
	if(time==1)
	  printf("<");
	else if(time==2)
	  printf(">");
	else if(time==3){
	  printf(",");
	}
	break;
	
  case COLUMN:    /* $BNs$N6h@Z$j(B  */
	if(time==1)  /* $BA0$N(B,$B$r>C$7$F!#!#(B\b$B>C$7$?$iI,MW$JM}M3$o$+$k$+$b(B */
	  printf("\b%s",sp->value);   /*$B=DK@$r;R6!$rI=<($9$k$^$($K0u;z(B  */
	break;


  case DUMMYCOMMA:   /* $BJQ49;~$K$&$^$l$k%@%_!<$N?F(B($B%3%s%^$@$1$O$D$1$k(B) */
	if(time==3)
	  printf(",");
	break;    /* $B$J$K$b$7$J$$$,;R6!$N4V$K%3%s%^$@$1$O$$$l$k(B */
  }
}
